
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>forms验证的方式和使用 / iVAN</title>

    <meta name="description" content="forms验证的方式和使用 如何运用 Form 表单认证 ASP.NET 的安全认证,共有&quot;Windows&quot;&quot;Form&quot;&quot;Passport&quot;&quot;None&quot;四种验证模式.&quot;Windows&quot;与&quot;None&quot;没有起到保护的作用,不推荐使用:&quot;Passport&quot;我又没用过,唉--所以我只好讲讲&quot;Form&quot;认证了.我打算分三部分: 第一部分 -- 怎样实现From 认证: 第二部 ...">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/bootstrap.css" rel="stylesheet">
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
  <script>
  var _hmt = _hmt || [];
  (function() {
    var hm = document.createElement("script");
    hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
    var s = document.getElementsByTagName("script")[0]; 
    s.parentNode.insertBefore(hm, s);
  })();
  </script>
 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="https://pic.ikafan.com/staticx/iamivan/2/assets/logo.png" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/">首页</a></li>
            <li><a href="/tag/互联网/">互联网</a></li>
            <li><a href="/tag/java/">java</a></li>
            <li><a href="/tag/mysql/">mysql</a></li>
            <li><a href="/tag/android/">Android</a></li>
            <li><a href="/tag/ios/">IOS</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    <div id="main" class="col-md-8">


<h1 class="mtitle">forms验证的方式和使用</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>

    	<section>
		<article class="clearfix">
		<p>如何运用 Form 表单认证</p>
<p>ASP.NET 的安全认证，共有“Windows”“Form”“Passport”“None”四种验证模式。“Windows”与“None”没有起到保护的作用，不推荐使用；“Passport”我又没用过，唉……所以我只好讲讲“Form”认证了。我打算分三部分：</p>
<p>第一部分 —— 怎样实现From 认证；</p>
<p>第二部分 —— Form 认证的实战运用；</p>
<p>第三部分 —— 实现单点登录（Single Sign On）</p>
<p>第一部分 如何运用 Form 表单认证</p>
<p>一、     新建一个测试项目</p>
<p>为了更好说明，有必要新建一个测试项目（暂且为“FormTest”吧），包含三张页面足矣（Default.aspx、Login.aspx、UserInfo.aspx）。啥？有人不会新建项目，不会新增页面？你问我咋办？我看这么办好了：拖出去，打回原藉，从幼儿园学起……</p>
<p>二、     修改 Web.config</p>
<p>1、 双击项目中的Web.config（不会的、找不到的打 PP）</p>
<p>2、 找到下列文字 &lt;authentication mode="Windows" /&gt; 把它改成：</p>
<p>&lt;authentication mode="Forms"&gt;</p>
<p>&lt;forms loginUrl="Login.aspx" name=".ASPXAUTH"&gt;&lt;/forms&gt;</p>
<p>&lt;/authentication&gt;</p>
<p>3、 找到&lt;authorization&gt; &lt;allow users="*" /&gt;&lt;/authorization&gt;换成</p>
<p>&lt;authorization&gt;&lt;deny users="?"&gt;&lt;/deny&gt;&lt;/authorization&gt;</p>
<p>这里没什么好说的，只要拷贝过去就行。虽说如此，但还是有人会弄错，如下：</p>
<p>&lt;authentication mode="Forms"&gt;</p>
<p>    &lt;forms loginUrl="Login.aspx" name=".APSX"&gt;&lt;/forms&gt;</p>
<p>&lt;deny users="?"&gt;&lt;/deny&gt;</p>
<p>&lt;/authentication&gt;</p>
<p>若要问是谁把 &lt;deny users="?"&gt;&lt;/deny&gt; 放入 &lt;authentication&gt; 中的，我会很荣幸地告诉你，那是 N 年前的我：&lt;authentication&gt; 与 &lt;authorization&gt; 都是以 auth 字母开头又都是以 ation 结尾，何其相似；英文单词背不下来的我以为他们是一伙的……</p>
<p>三、     编写 .cs 代码——登录与退出</p>
<p>1、 登录代码：</p>
<p>a、 书本上介绍的</p>
<p>      private void Btn_Login_Click(object sender, System.EventArgs e)</p>
<p>      {</p>
<p>        if(this.Txt_UserName.Text=="Admin" &amp;&amp; this.Txt_Password.Text=="123456")</p>
<p>        {</p>
<p>System.Web.Security.FormsAuthentication.RedirectFromLoginPage(this.Txt_UserName.Text,false);</p>
<p>}</p>
<p>}</p>
<p>b、 偶找了 N 久才找到的</p>
<p>private void Btn_Login_Click(object sender, System.EventArgs e)</p>
<p>      {<br />        if(this.Txt_UserName.Text=="Admin" &amp;&amp; this.Txt_Password.Text=="123456")<br />        {</p>
<p>System.Web.Security.FormsAuthentication.SetAuthCookie(this.Txt_UserName.Text,false);</p>
<p>Response.Redirect("Default.aspx");</p>
<p>}<br />}</p>
<p>以上两种都可发放验证后的 Cookie ，即通过验证，区别：</p>
<p>方法 a) 指验证后返回请求页面，俗称“从哪来就打哪去”。比如：用户没登录前直接在 IE 地址栏输入 http://localhost/FormTest/UserInfo.aspx ，那么该用户将看到的是 Login.aspx?ReturnUrl=UserInfo.aspx ，输入用户名与密码登录成功后，系统将根据“ReturnUrl”的值，返回相应的页面</p>
<p>方法 b) 则是分两步走：通过验证后就直接发放 Cookie ，跳转页面将由程序员自行指定，此方法多用于 Default.aspx 使用框架结构的系统。</p>
<p>2、 退出代码：</p>
<p>private void Btn_LogOut_Click(object sender, System.EventArgs e)<br />{</p>
<p>System.Web.Security.FormsAuthentication.SignOut();</p>
<p>}</p>
<p>四、     如何判断验证与否及获取验证后的用户信息</p>
<p>有的时候，在同一张页面需要判断用户是否已经登录，然后再呈现不同的布局。有人喜欢用 Session 来判断，我不反对此类做法，在此我只是想告诉大家还有一种方法，且看下面代码：</p>
<p>if(User.Identity.IsAuthenticated)<br />{</p>
<p>        //你已通过验证，知道该怎么做了吧？</p>
<p>}</p>
<p>User.Identity 还有两个属性AuthenticationType（验证类型）与 Name（用户名称） ，大家要注意的是 Name 属性，此处的User.Identity.Name将得到，验证通过（RedirectFromLoginPage 或SetAuthCookie）时，我们带入的第一个参数 this.Txt_UserName.Text 。这个参数很重要，关系到种种……种种的情况，何出此言，且听下回分解……<br />灵活运用 Form 表单认证中的 deny 与 allow 及保护 .htm 等文件</p>
<p>第二部分 Form 认证的实战运用</p>
<p>Web.config 的作用范围</p>
<p>新建项目时， VS.Net 会在项目根目录建立一个内容固定的 Web.config。除了在项目根目录，你还可以在任一目录下建立 Web.config ，条件就是应用程序级别的节点只能在根目录的 Web.config 中出现。至于哪些是应用程序级别节点呢，这个问题嘛，其实我也不太清楚，呵呵。电脑不是我发明的，微软不是我创建的，C# 更不是我说了算的，神仙也有不知道的，所以我不晓得是正常的。话虽如此，只要它不报错，那就是对的。</p>
<p>关于 Web.config 设置的作用范围，记住以下两点：</p>
<p>1、 Web.config 的设置将作用于所在目录的所有文件及其子目录下的所有东东（继承：子随父姓）</p>
<p>2、 子目录下的 Web.config 设置将覆盖由父目录继承下来的设置（覆盖：县官不如现管）</p>
<p>给大家提个问题：有没有比根目录Web.config 的作用范围还大的配置文件呢？看完第三部分便知分晓。</p>
<p>六、     学会拒绝与巧用允许</p>
<p>回到我们在第一回合新建的测试项目“FormTest” ，既然要进行验证，按国际惯例，就得有用户名与密码。那，这些用户是管理员自己在数据库建好呢，还是用户注册、管理员审核好呢。只要不是一般的笨蛋，都知道选择后者。你们还别说，我公司还真有个别项目是管理员连到数据库去建帐号的，属于比较特殊的笨蛋，咱们不学他也罢，还是老老实实添加两个页面吧——注册页面（Register.aspx）与审核页面（Auditing.aspx）。</p>
<p>问题终于就要浮出水面啦，当你做好 Register.aspx 时，想访问它的时候突然觉得不对劲，怎么又回到了登录页面？你仔细瞧瞧网址，是不是成了：Login.aspx?ReturnUrl=Register.aspx 。怎么办，用户就是因为没有帐号才去访问注册页面的呀？（这句纯属废话，有帐号谁还跑去注册。）我时常对我的同事说：“办法是人想出来滴！！”</p>
<p>1、 新建一个目录 Public ，用于存放一些公用的文件，如万年历、脚本呀……</p>
<p>2、 在“解决方案资源管理器”中右击点击目录 Public ，新增一个 Web.config</p>
<p>3、 把上述 Web.config 的内容统统删除，仅留以下即可：</p>
<p>&lt;?xml version="1.0" encoding="utf-8"?&gt;</p>
<p>&lt;configuration&gt;</p>
<p>&lt;system.web&gt;</p>
<p>&lt;authorization&gt;&lt;allow users="*"/&gt;&lt;/authorization&gt;</p>
<p>&lt;/system.web&gt;</p>
<p>&lt;/configuration&gt;</p>
<p>终于切入正题了，不容易呀。根据“覆盖”原则，我们知道上述 Web.config 将替代根目录 Web.config 中的 &lt;authorization&gt; 节点设置，即：</p>
<p>    &lt;allow users="*"/&gt; 替换 &lt;deny users="?"&gt;&lt;/deny&gt;</p>
<p>注解：“allow”允许的意思；“*”表示所有用户；</p>
<p>    “deny” 拒绝的意思；“?”表示匿名用户；</p>
<p>因此，处于 Public 目录下的文件，允许所有人浏览，包括未验证的用户。把 Register.aspx 拖进来吧，再也不会有人阻止你浏览啦。</p>
<p>除了注册页面，我们还提到一个审核页面（Auditing.aspx），审核权限一般都在管理员或主管手里，并不想让其他人浏览此页面（真理往往掌握在少数人的手里，这也是没法子的事），怎么办？“办法是人想出来滴”呵呵……新建一个管理员的目录 ManageSys ，在此目录下再新增一个 Web.config。内容如下：</p>
<p>&lt;?xml version="1.0" encoding="utf-8"?&gt;</p>
<p>&lt;configuration&gt;</p>
<p>&lt;system.web&gt;</p>
<p>&lt;authorization&gt;</p>
<p>&lt;allow users="Admin"/&gt;</p>
<p>&lt;deny users="*"/&gt;</p>
<p>&lt;/authorization&gt;</p>
<p>&lt;/system.web&gt;</p>
<p>&lt;/configuration&gt;</p>
<p>System.Web.Security.FormsAuthentication.SetAuthCookie(this.Txt_UserName.Text,false); //通过验证，发放 Cookie</p>
<p>之前我曾强调，要注意，第一个参数很重要，重要到什么程度？说到这，恐怕地球人都知道了——它就是allow与deny的依据。假如此处用户填写的是“Admin”即 this.Txt_UserName.Text = "Admin"; 那么进入系统后，他就能访问 ManageSys 目录下的网页了，其它闲杂人等一律拒之门外。</p>
<p>以上 from</p>
<p>1: 在web.config中，加入form认证；</p>
<p>    &lt;authentication mode="Forms"&gt;<br />   &lt;forms name="auth" loginUrl="index.aspx" timeout="30"&gt;&lt;/forms&gt;<br />&lt;/authentication&gt;<br />&lt;authorization&gt;<br />   &lt;deny users="?" /&gt;<br />&lt;/authorization&gt;<br />2: 如果有注册页面时还应该允许匿名用户调用注册页面进行注册;<br />以下代码应该在&lt;configuration&gt;&lt;system.web&gt;之间,而不应该包含到&lt;system.web&gt;..&lt;/system.web&gt;之间;<br />----------------表示允许 匿名用户对 userReg.aspx页面进行访问.<br />&lt;location path="userReg.aspx"&gt;<br />   &lt;system.web&gt;<br />    &lt;authorization&gt;<br />     &lt;allow users="?" /&gt;<br />    &lt;/authorization&gt;<br />   &lt;/system.web&gt;<br />&lt;/location&gt;<br />3 在登录成功后要 创建身份验证票, 表明已经通过认证的合法用户;</p>
<p>if(登陆成功)</p>
<p>System.Web.Security.FormsAuthentication.SetAuthCookie(用户名称, false);</p>
<p>1.使用Forms验证存储用户自定义信息</p>
<p>Forms验证在内部的机制为把用户数据加密后保存在一个基于cookie的票据FormsAuthenticationTicket中，因为是经过特殊加密的，所以应该来说是比较安全的。而.net除了用这个票据存放自己的信息外，还留了一个地给用户自由支配，这就是现在要说的UserData。</p>
<p>UserData可以用来存储string类型的信息，并且也享受Forms验证提供的加密保护，当我们需要这些信息时，也可以通过简单的get方法得到，兼顾了安全性和易用性，用来保存一些必须的敏感信息还是很有用的。</p>
<p>下面来看怎么使用UserData，然后会给出一个实际使用的例子。</p>
<p>//创建一个新的票据，将客户ip记入ticket的userdata<br />FormsAuthenticationTicket ticket=new FormsAuthenticationTicket(<br />1,userName.Text,DateTime.Now,DateTime.Now.AddMinutes(30),<br />false,Request.UserHostAddress);<br />//将票据加密<br />string authTicket=FormsAuthentication.Encrypt(ticket);<br />//将加密后的票据保存为cookie<br />HttpCookie coo=new HttpCookie(FormsAuthentication.FormsCookieName,authTicket);<br />//使用加入了userdata的新cookie<br />Response.Cookies.Add(coo);</p>
<p>下面是FormsAuthenticationTicket构造函数的重载之一的方法签名<br />public FormsAuthenticationTicket(<br />int version,<br />string name,<br />DateTime issueDate,<br />DateTime expiration,<br />bool isPersistent,<br />string userData<br />);</p>
<p>参数<br />version<br />版本号。<br />name<br />与身份验证票关联的用户名。<br />issueDate<br />Cookie 的发出时间。<br />expiration<br />Cookie 的到期日期。<br />isPersistent<br />如果 Cookie 是持久的，为 true；否则为 false。<br />userData<br />将存储在 Cookie 中的用户定义数据</p>
<p>使用userdata也很简单，FormsIdentity的Ticket属性就提供了对当前票据的访问，获得票据后就可以用UserData属性访问保存的信息，当然是经过解密的。<br />((System.Web.Security.FormsIdentity)this.Context.User.Identity).Ticket.UserData</p>
<p>下面是一个具体的应用。</p>
<p>由于Forms验证是通过cookie来进行的，它需要传递一个票据来进行工作。虽然票据是加密的，里面的内容不可见，但这并不能阻止别人用一个假冒的身份使用票据（就像我们可以拿别人的钥匙去开别人的锁），比较常见的就是不同ip的用户在不安全通道截获了这个票据，然后使用它进行一些安全范围外的活动。</p>
<p>解决这个问题的办法之一就是使用SSL来传递信息。</p>
<p>但是如果不能使用SSL呢？我们可以判断ip和票据是否匹配，如果发出请求的ip是初次产生票据的ip，则没有问题，否则就销毁这个票据。</p>
<p>为此，我们需要在一开始处理登录时将用户的ip保存起来，这样就可以在以后的请求中随时验证后继请求的ip是否和初始ip相同。保存这个敏感ip的最佳场所当然是UserData啦，而验证的时机则是在AuthenticateRequest事件发生时，即Global.aspx.cs中定义的处理此事件的Application_AuthenticateRequest方法中。</p>
<p>上面的示例实际上已经是把用户ip保存到了UserData中，下面是验证的过程。</p>
<p>if(this.Request.IsAuthenticated)<br />{<br />if(((System.Web.Security.FormsIdentity)this.Context.User.Identity).Ticket.UserData !=this.Request.UserHostAddress)<br />{<br />System.Security.Principal.GenericIdentity gi=new System.Security.Principal.GenericIdentity("","");<br />string[] rolesi={};<br />System.Security.Principal.GenericPrincipal gpi=new System.Security.Principal.GenericPrincipal(gi,rolesi);<br />this.Context.User=gpi;<br />}<br />}</p>
<p>通过给GenericPrincipal空的GenericIdentity和roles使票据失效，这样将强迫用户重新登录。为了测试这个方法，可以先把条件改为相等，看效果如何 ：）</p>
<p>这个方法也有不足之处，具体为：</p>
<p>1.使用同一代理的用户将拥有同一个ip，这样就不能防范此类假冒攻击了</p>
<p>2.如果用户使用动态ip，则可能造成正常用户被我们强行销毁票据。不过总的来说，这个办法还是比较可行的。</p>
<p>2.使用安全特性配合Forms验证进行安全操作。</p>
<p>PrincipalPermissionAttribute可以配合Forms验证进行基于角色或用户的安全验证，该特性不能用于程序集级别。它的作用范围可以是类或具体的方法。来看一个简单的示例。</p>
<p>[PrincipalPermission(SecurityAction.Demand,User="Notus")]<br />public class Test : BasePage<br />{<br />private void Page_Load(object sender, System.EventArgs e)<br />{<br />try<br />{<br />this.sayHello();<br />this.sayHello2();<br />}<br />catch(Exception ex)<br />{<br />Response.Write(ex.ToString());<br />}<br />}</p>
<p>private void sayHello()<br />{<br />Response.Write("hello world!");<br />}</p>
<p>private void sayHello2()<br />{<br />Response.Write("hello PrincipalPermissionAttribute!");<br />}</p>
<p>#region Web 窗体设计器生成的代码<br />override protected void OnInit(EventArgs e)<br />{<br />//<br />// CODEGEN: 该调用是 ASP.NET Web 窗体设计器所必需的。<br />//<br />InitializeComponent();<br />base.OnInit(e);<br />}</p>
<p>/// &lt;summary&gt;<br />/// 设计器支持所需的方法 - 不要使用代码编辑器修改<br />/// 此方法的内容。<br />/// &lt;/summary&gt;<br />private void InitializeComponent()<br />{<br />this.Load += new System.EventHandler(this.Page_Load);<br />}<br />#endregion</p>
<p>}</p>
<p>注意这个例子一开始是作用于整个类的，生成后执行，如果当前用户不是Notus，就会发生异常System.Security.SecurityException，提示对主体权限的请求失败。反之，则可以顺利访问，并输出两个hello world!，注意是两个。现在的安全作用范围是整个类。</p>
<p>接下来我们改一下特性的作用范围。将特性声明移到sayHello2方法上面，重新编译后运行，就会发现程序在运行到sayHello2方法后抛出了System.Security.SecurityException。这说明现在安全作用范围缩小到了方法级别。</p>
<p>该特性可以通过设置User和Role来进行基于用户和角色的安全保护。另外其使用的第一个参数是SecurityAction枚举，该枚举设置了具体的保护级别或措施。像我们现在使用的这个Demand，是要求调用堆栈中的所有高级调用方都已被授予了当前权限对象所指定的权限。</p>
<p>下面是msdn给的示例</p>
<p>示例</p>
<p>下面的示例说明可以如何以声明方式使用 PrincipalPermission 要求当前用户是 Bob 并且属于 Supervisor 角色。<br />[PrincipalPermissionAttribute(SecurityAction.Demand, Name="Bob",<br />Role="Supervisor")]下面的示例说明如何要求当前用户的身份是 Bob，与角色成员条件无关。<br />[PrincipalPermissionAttribute(SecurityAction.Demand, Name="Bob")]<br />下面的示例说明如何仅要求对用户进行身份验证。<br />[PrincipalPermissionAttribute(SecurityAction.Demand, Authenticated=true)]</p>
<p>再要说一下的是，这里面的User和Role是可以和Forms验证集成的，据此，我们可以在一些重要的类或方法中使用PrincipalPermissionAttribute，以将自己的程序武装到家。</p>
<p>而实际上，该特性的作用远不止这些，更详细的信息可以查阅msdn。</p>
<p>或者:<br />1.配置Web.Config文件</p>
<p>设置为Form认证:<br />&lt;authentication mode="Forms"&gt;<br />      &lt;forms name="oursnet" loginUrl="login.aspx" timeout="10" /&gt;<br />&lt;/authentication&gt; <br />其中:<br />        name:        决定验证用户时所使用的Cookie名称<br />        loginurl:     在用户没有登录是,被重定向的页面<br />        timeout:     超时时间,单位为分钟</p>
<p>不允许匿名登录<br />&lt;authorization&gt;<br />         &lt;!-- 允许所有用户 --&gt;<br />&lt;deny users="?" /&gt;<br />            &lt;!-- &lt;allow     users="[逗号分隔的用户列表]"<br />                             roles="[逗号分隔的角色列表]"/&gt;<br />                  &lt;deny      users="[逗号分隔的用户列表]"<br />                             roles="[逗号分隔的角色列表]"/&gt;<br />            --&gt;<br />&lt;/authorization&gt;<br />其中:<br />        users:    表示禁止访问资源的用户列表,使用通配符“?“拒绝匿名用户访问,使用"*",则表示拒绝所有的用户访问.</p>
<p>2.添加登录成功的代码:</p>
<p>    Session.Contents["UserName"]=txtUser.Text;<br />    FormsAuthentication.RedirectFromLoginPage(txtUser.Text,false);<br />    Response.Redirect("index.aspx");</p>
<p>3.添加退出时的代码<br />   System.Web.Security.FormsAuthentication.SignOut();<br />   Response.Redirect("login.aspx");</p>
<p> </p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-02-19 11:01:37</div>
		
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong> <a href="https://www.iamivan.net/tag/%e5%8a%a0%e5%af%86/" title="加密">加密</a>, <a href="https://www.iamivan.net/tag/%e5%ae%89%e5%85%a8/" title="安全">安全</a>, <a href="https://www.iamivan.net/tag/%e6%a0%b9%e7%9b%ae%e5%bd%95/" title="根目录">根目录</a>, <a href="https://www.iamivan.net/tag/web/" title="web">web</a>, <a href="https://www.iamivan.net/tag/security/" title="Security">Security</a>, <a href="https://www.iamivan.net/tag/aspx/" title="aspx">aspx</a>        </div> -->
	</section>
	
	

		<div id="similar">

		<h3>forms验证的方式和使用的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MR7y2Bp.html" rel="bookmark">当ASP&period;NET Forms验证方式遭遇苹果IOS</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				一.问题出现 我在用ASP.NET MVC4做微信开发的时候,用Forms验证方式做为authentication. 一般都是在web.config加: &lt;authentication mode=&quot;Forms&quot; &gt; &lt;forms loginUrl=&quot;~/Account/Login&quot; name=&quot;webcookies&quot;  slidingExpiration=&quot;true&quot; timeout=&quot;30&quo			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/xp8e1lz.html" rel="bookmark">扩展Forms验证</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				1.使用Forms验证存储用户自定义信息 Forms验证在内部的机制为把用户数据加密后保存在一个基于cookie的票据FormsAuthenticationTicket中,因为是经过特殊加密的,所以应该来说是比较安全的.而.net除了用这个票据存放自己的信息外,还留了一个地给用户自由支配,这就是现在要说的UserData. UserData可以用来存储string类型的信息,并且也享受Forms验证提供的加密保护,当我们需要这些信息时,也可以通过简单的get方法得到,兼顾了安全性和易用性,用来保			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/0zG43ob.html" rel="bookmark">Asp&period;net中基于Forms验证的角色验证授权</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				asp.net Asp.net中基于Forms验证的角色验证授权 Asp.net的身份验证有有三种,分别是&quot;Windows | Forms | Passport&quot;,其中又以Forms验证用的最多,也最灵活.Forms 验证方式对基于用户的验证授权提供了很好的支持,可以通过一个登录页面验证用户的身份,将此用户的身份发回到客户端的Cookie,之后此用户再访问这个web应用就会连同这个身份Cookie一起发送到服务端.服务端上的授权设置就可以根据不同目录对不同用户的访问授权进行控制了. 问			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/qbayynb.html" rel="bookmark">asp&period;net中使用基于角色的身份Forms验证&comma;大致分为四个步骤</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				asp.net asp.net中使用基于角色的身份Forms验证,大致分为四个步骤1.配置系统文件web.config&lt;system.web&gt; &lt;authentication mode=&quot;Forms&quot; &gt;  &lt;forms name=&quot;.yaoCookies&quot; loginUrl=&quot;/duan/Manage/login.aspx&quot; protection=&quot;All&quot;  timeout=&quot;20&			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/bo6ZkXz.html" rel="bookmark">ASP&period;NET Forms验证实现子域名&lpar;SubDomain&rpar;共享登陆下的缺陷</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				一.什么是单点登录 单点登录就是在多个web应用程序中,实现统一登录方式,一但登录了某web应 用程序,其它相关联的web应用程序都无需再次登录,一个地方退出,所有相关联的 web应用程序都退出. 二.通过利用ASP.NET Forms验证模式可以实现子域名(SubDomain)共享登陆下 的缺陷 要利用Asp.NET Form验证模式实现同一主域下不同子域名共享登陆状态需要进 行以下配置 配置Web.config 1.把Asp.net的认证模式改为Forms认证模式,domain 要等于你的应			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/z40J7rz.html" rel="bookmark">ASP&period;NET Forms验证的安全性问题研究为什么加密代码需要配置为服务</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				申明:这个帖子不是要你去干啥坏事,就是提醒一下你可能会遇到的安全性问题. ASP.Net提供了内置的登录验证,最为常用的就是Forms验证.讲解如何配置的文章非常多,这里就不再讲如何配置使用这个验证的方式了.下面讲讲其在安全性上存在的一些被忽视的问题.其实它本身没有问题,而使用的方式上会附带出来一些问题. 本文将分三部分讲实际应用中将会遇到的安全性问题,并且加以研究,并尝试提出解决方案. 一.简单的Forms被破解危机二.垂直划分站点的Forms被破解危机三.危机将带来什么后果 一.简单的For			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MY4R6Bb.html" rel="bookmark">艾伟&lowbar;转载：ASP&period;NET Forms验证的安全性问题研究&mdash;&mdash;为什么加密代码需要配置为服务</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				申明:这个帖子不是要你去干啥坏事,就是提醒一下你可能会遇到的安全性问题. ASP.Net提供了内置的登录验证,最为常用的就是Forms验证.讲解如何配置的文章非常多,这里就不再讲如何配置使用这个验证的方式了.下面讲讲其在安全性上存在的一些被忽视的问题.其实它本身没有问题,而使用的方式上会附带出来一些问题. 本文将分三部分讲实际应用中将会遇到的安全性问题,并且加以研究,并尝试提出解决方案. 一.简单的Forms被破解危机二.垂直划分站点的Forms被破解危机三.危机将带来什么后果    一.简单的			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/4MYLvQb.html" rel="bookmark">Forms验证中的roles</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				    一直对forms验证中的角色很模糊,不知道怎么搞,昨天晚上仔细看了下csdn的杂志,心里稍微有点底,今天早晨一上csdn,就看到思归大人回的一篇贴,是关于asp.net中的forms验证roles,地址是:http://www.codeproject.com/aspnet/formsroleauth.asp汗,怎么是E文,我的e文特差,但是不知道为什么这次竟然被我看懂了,模仿他的做,竟然成功!,特把过程以及我的理解写出来,希望对和我一样的菜鸟有点帮助,同时我的一些理解可能错误,希望各位老			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MgK9vZM.html" rel="bookmark">ASP&period;NET安全问题－－Forms验证的具体介绍&lpar;上篇&rpar;</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				前言:在ASP.NET中,常用的就是Forms验证,最重要的原因就是灵活.因为Forms验证细细的谈起来也确实不少,而且我也不想草草的说完了事,那对大家和自己都不负责任的. 本篇的话题如下: Forms验证的工作原理 Forms验证中的API Forms验证的工作原理 我们知道,Forms验证主要是基于cookie的,说白一点就是:把用户信息保存在cookie中,然后发送到客户端:再就是解析客户端的发送了的cookie信息,进行解析,然后进行验证.关于cookieless的工作原理和方法,我这里			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/LzJDAqM.html" rel="bookmark" class="title">使用情境决定设计一致性原则</a>
					<div>
						一致性是设计中很普遍的概念.良好的一致性会帮助企业塑造起品牌形象.大大减少顾客/用户的学习成本和认知成本:从系统的角度看,高度一致化的流程也是保证产品质量和运营效率的基础.此间最著名的实例莫过于麦当劳 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/XpmZN5z.html" rel="bookmark" class="title">网站建设与优化 最不能忽视的就是细节</a>
					<div>
						细节决定成败,对于网站建设和网站优化来说,细节也是制胜的最为关键的一个环节.从最初的域名主机选购,到实施过程中的页面美术设计及程序编写:从网站优化工作的步步努力,到网站稳定安全运行保障.可以说,网站建 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/z4wyArp.html" rel="bookmark" class="title">大话数据结构九：队列的链式存储结构（链队列）</a>
					<div>
						1. 链队列的特点: 链队列其实就是单链表,只不过它是先进先出的单链表,为了实现方便,程序中设置了队头(front),队尾(rear)两个指针. 2. Java使用链表实现队列: //结点类,包含结点 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zOwlemz.html" rel="bookmark" class="title">ie地址栏常用的使用方法</a>
					<div>
						使用过IE的朋友都知道,在IE地址栏中输入网站网址就可以访问各种网站,其实在IE中地址栏还具有其他的一些使用功能,了解掌握这些功能的使用方法可以为我们使用电脑带来极大的方便.现将IE地址栏的一些使用方 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zOwJP3z.html" rel="bookmark" class="title">Windows网络服务架构系列课程详解（二） DNS服务器的部署与配置</a>
					<div>
						实验背景: 在Internet网络发展的早期,由于IP地址不便于记忆,网络互联的方式主要通过购买hosts文件进行域名的解析,当时,进行网络互联的计算机并不是很多.随后,随着计算机网络的不断发展和普及 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/p8jY3Zb.html" rel="bookmark" class="title">FLV视频无法在win2003主机播放的问题</a>
					<div>
						FLV是FLASH VIDEO的简称,是一种比较好的视频格式.和SWF格式相比,FLV格式视频的优势在于形成的文件小.加载速度快.可以边加载边播放. 如果是独立服务器,可在IIS中网站HTTP头的&q ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bo6qydz.html" rel="bookmark" class="title">&OpenCurlyDoubleQuote;截&rdquo;出精彩-简单实用的Lava截图功能</a>
					<div>
						Lava-Lava的截图功能一直是网友们所津津乐道的,不仅操作方便,而且还相当实用,特别是它的高级截屏功能,让你在截图后无须再打开图片处理软件,就可以直接编辑,加框或者标注等. 有了Lava-Lava ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MAaLq3M.html" rel="bookmark" class="title">Excel单元格中画表格也有诀窍</a>
					<div>
						通过渐变颜色直观地掌握数据的整体分布情况 在一个单元格区域中显示双色渐变或三色渐变,颜色的底纹表示单元格中的值,并且渐变颜色能够智能地随数据值的大小而改变,非常强悍吧.新版Excel带来的全新的&qu ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Mq8Lkkb.html" rel="bookmark" class="title">ps打造专业染发</a>
					<div>
						先看效果对比. 打开一幅图片,长发女人的最好,用减淡工具在头发高光处涂抹几下,增加头发光泽. 建立新层,用套索工具画一选区,填充颜色. 画出其它选区,填充颜色. 去掉选区,高斯模糊3像素左右,图层模式 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zOaok9M.html" rel="bookmark" class="title">测试和使用DNS服务</a>
					<div>
						  如果提前将网站放到了指定的服务器上或服务器指定的位置上,则直接在xp系统下载的IE浏览器的地址栏中输入域名Webserver,ynkm.com后按&quot;Enter&quot;键,便可成功访问 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Myw774z.html" rel="bookmark" class="title">网页-Android开发之中，是否可以运行js代码。</a>
					<div>
						问题描述 Android开发之中,是否可以运行js代码. Android开发过程之中,我需要异步登陆其他网站并解析其网页.在进行模拟登陆过程之中需要对输入的用户名和密码进行加密.现在已经有了网站加密的 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MYj30Qp.html" rel="bookmark" class="title">CentOS安装nexus&lpar;Maven仓库管理器&rpar;</a>
					<div>
						Nexus是一个强大的Maven仓库管理器, 它极大地简化了自己内部仓库的维护和外部仓库的访问. 利用Nexus你可以只在一个地方就能够完全控制访问和部署在你所维护仓库中的每个Artifact. Ne ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M6NDNgM.html" rel="bookmark" class="title">关于远程连接MySQL数据库的问题解决</a>
					<div>
						问题描述 出于兴趣,本人在Windows和Ubuntu系统上均安装了MySQL服务器和客户端.现在有这样一些预备信息: Windows系统的IP地址: 192.168.5.196 Ubuntu系统的I ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M6ZQYyM.html" rel="bookmark" class="title">密码破解</a>
					<div>
						问题描述 各位大大好,小弟的问题很简单,但是不好弄.小弟想做的就是类似于人人这样的网页用户,知道他的登陆账号,但是不知道密码,如何做才能登进他的账号呢?跪求跪求跪求其实我登陆的红娘网 解决方案 解决方 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/boKDPjb.html" rel="bookmark" class="title">网站优化的3个seo小技巧</a>
					<div>
						网站运营的基础就是优化,对于很多人来讲,想要把网站做好,提升排名,无疑是一件比较苦恼的事.但是做网站优化,实际上也并没有想的那么复杂,有时候我们可以运用一些优化技巧,就可以把网站优化做好.   做好网 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/p5ZPXDz.html" rel="bookmark" class="title">&period;net  nhibernate框架 怎么样下sql 语句啊</a>
					<div>
						问题描述 using(varfactory=newBaseAccess()){factory.DbContext.ExecuteString(&quot;&quot;,);}这里怎么写sql语句啊 解 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zeo4gxM.html" rel="bookmark" class="title">【全网首发】2014款Basis Carbon Steel Edition实测</a>
					<div>
						     本文来自雷锋网(公众号:雷锋网)的好基友.顺为基金的段誉同学. 等了快 2 个月,终于拿到了 2014 款的 Basis Carbon Steel Edition. 1. 开箱: 不多说了, ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MYXg5lb.html" rel="bookmark" class="title">12306网站假身份证也可购票 黄牛以此抢票退票再回购</a>
					<div>
						相关新闻:12306验证码从晃动改为干扰线官方:为保护旅客12306网站假身份证也可购票 黄牛以此抢票退票再回购原标题:12306现漏洞黄牛假证囤票继春运购票首日查询等功能无法使用后,12306再现漏 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/baBeJqM.html" rel="bookmark" class="title">如何从零开始用asp&period;net和c&num;写一个网页登录项目？</a>
					<div>
						问题描述 第一次接触asp.net,有一个作业要求写一个网页端的登录程序,数据库已建好,第一次做不知道怎么做,请教一下大家. 解决方案 解决方案二:1.项目连接上数据库2.新建一个登陆页面,3.在网页 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Mye88PM.html" rel="bookmark" class="title">java代码-请教各位大神，遍历数据库 为什么只有一条数据&comma;里面明明有两条数据，哪位大神帮忙看看</a>
					<div>
						问题描述 请教各位大神,遍历数据库 为什么只有一条数据,里面明明有两条数据,哪位大神帮忙看看 &lt;% Connection con; Statement stmt; ResultSet rs; C ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/z44R8jz.html" rel="bookmark" class="title">java使用异或实现变量互换和异或加密解密示例&lowbar;java</a>
					<div>
						复制代码 代码如下: import java.util.Scanner; public class VariableExchange {    public static void main(Stri ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pmVjN7z.html" rel="bookmark" class="title">PHP的cURL库功能简介 抓取网页、POST数据及其他&lowbar;php技巧</a>
					<div>
						无论是你想从从一个链接上取部分数据,或是取一个XML文件并把其导入数据库,那怕就是简单的获取网页内容,反应釜cURL 是一个功能强大的PHP库.本文主要讲述如果使用这个PHP库. 启用 cURL 设置 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/boLjnBM.html" rel="bookmark" class="title">JavaScript获取当前网页标题（title）的方法&lowbar;javascript技巧</a>
					<div>
						本文实例讲述了JavaScript获取当前网页标题(title)的方法.分享给大家供大家参考.具体如下: JS中的document.title可以获取当前网页的标题 &lt;!DOCTYPE html ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pk0yWyz.html" rel="bookmark" class="title">java代码通过HttpClient访问网站返回html的问题</a>
					<div>
						问题描述 我用java代码访问一个网址他返回的是一个html.javascript.css和外部的css.js可是这个页面body里有个onload方法在浏览器下执行的结果和java控制台输出的结果不 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MlAODYp.html" rel="bookmark" class="title">Web前端知识体系精简</a>
					<div>
						Web前端技术由html.css和javascript三大部分构成,是一个庞大而复杂的技术体系,其复杂程度不低于任何一门后端语言.而我们在学习它的时候往往是先从某一个点切入,然后不断地接触和学习新的知 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pLBKRRb.html" rel="bookmark" class="title">家国情灌筑品牌魂  解读章光101品牌文化</a>
					<div>
						2012年初春的经济走势乍暖还寒,著名财经评论家吴晓波的&quot;过冬论&quot;更加令人感到不安.对于后金融危机时代的中国企业来说,应当如何以品牌求生存,成为了众多http://www.aliy ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M9NRJKp.html" rel="bookmark" class="title">分区表查询条件使用浅析</a>
					<div>
						很多同学已经跨入了MaxCompute的殿堂,对分区表和非分区表有了初步了解,也充分意识到&quot;大数据量&quot;的信息表要尽可能的采用分区方式,因为这样在查询.统计.分析的时候,在WHERE ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/p5Yx4np.html" rel="bookmark" class="title">外链权重已经来到用户说了算的时代</a>
					<div>
						中介交易 http://www.aliyun.com/zixun/aggregation/6858.html&quot;&gt;SEO诊断 淘宝客 云主机 技术大厅 做SEO无非就是三点,1,制作对用 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pPWjmmM.html" rel="bookmark" class="title">参股公司进入上市程序</a>
					<div>
						鲁信高新(600783)公告,2010年5月12日,公司的全资子公司山东省高新技术投资有限公司收到中国证监会山东监管局出具的&lt;中国证监会山东监管局辅导登记材料受理单&gt;,其参股公司通裕重工股 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bjo3P5M.html" rel="bookmark" class="title">盘锦打造中国石油装备制造基地</a>
					<div>
						1月20日,中油辽河宝石石油装备有限公司揭牌仪式在辽河石油勘探局装备工程公司隆重举行.盘锦市委.市政府.辽河石油勘探局.中国石油天然气集团公司.中国石油物资装备(集团)总公司等的主要领导为新公司揭牌. ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>热搜</span>
		</div>
		<div class="box-content">
					</div>
	</div>


</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 iVAN        | info#iamivan.net        | 11 q. 0.044 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <!-- <script src="/assets/js/jquery.js"></script>
  <script src="/assets/js/bootstrap.min.js"></script> -->
  <div style=" display: none ";>
  </div>

<script src="/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
    </script>
</body>
</html>
